#include <avr/io.h>
#include <avr/wdt.h>
//#include <avr/interrupt.h>

#include "initial.h"

void PortInit( void )
{
 	 DDRB  = 0xff;
 	 PORTB = 0x00;

 	 DDRC  = ( 1 << PC5 )|( 1 << PC4 )|( 1 << PC3 )|
	 	   	 ( 1 << PC2 )|( 0 << PC1 )|( 0 << PC0 ); 	 
 	 PORTC = ( 1 << PC1 )|( 1 << PC0 );     
	 
 	 DDRD  = 0xff;	
	 PORTD = 0x00;	
}	


void TimerInit( void )
{
//TIMER2 initialize - prescale:32
// WGM: CTC
// desired value: 1mSec
// actual value:  1.004mSec (0.4%)
// timer2_init
	 	TCCR2B = 0x00; //stop
 		ASSR   = 0x00; //set async mode
 		TCNT2  = 0x06; //setup
 		OCR2A  = 0xFA;
 		OCR2B  = 0x00;
 		TCCR2A = 0x02; 
 		TCCR2B = 0x03; //start
}

void InitOtherAll( void )
{
		wdt_reset( ); //this prevents a timout on enabling
		//wdt_enable( 3 );
		wdt_enable( WDTO_250MS );	
	
	 	MCUCR = 0x00;
	 	EICRA = 0x00; //extended ext ints
	 	EIMSK = 0x00;
	 
	 	TIMSK0  = 0;		//timer 0 interrupt sources
	 	TIMSK1  = 0;		//timer 1 interrupt sources 
	 	TIMSK2  = 2;		//timer 2 interrupt sources	
	 
	 	PCMSK0 = 0;		//pin change mask 0 
	 	PCMSK1 = 0;		//pin change mask 1 
	 	PCMSK2 = 0;		//pin change mask 2
	 	PCICR  = 0;		//pin change enable 
	 	PRR    = 0;		//power controller
}

void Init_Mega48( void )
{
		PortInit( );
		TimerInit( );
		InitOtherAll( );
}
