#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

#include "main.h"
#include "initial.h"
#include "timerdeal.h"
#include "keyscan.h"

volatile uint8_t main_Flage1;
uint8_t m_LedTimer;

//#pragma interrupt_handler Timer2_Compa_Isr:8
//void Timer2_Compa_Isr( void )
//SIGNAL( TIMER2_COMPA )
ISR( TIMER2_COMPA_vect )
{
 		SET_T_1MS_BIT( );
}

void Led_Deal( void )
{
		if( IF_LED_LONG_ON_BIT( ) )
		{
			PORTC |= 0b00111100;
		}
		else if( IF_LED_DIR_BIT( ) )		//left light the 4 LEDs
		{
			m_LedTimer *= 2;	
					
			if( m_LedTimer >= 16 )
			{
				m_LedTimer = 1;	
			}
			
			PORTC &= 0b11000011;
			PORTC |= ( m_LedTimer << 2 );
		}
		else
		{
			if( m_LedTimer == 1 )
			{
				m_LedTimer = 16;
			}
			
			m_LedTimer /= 2;

			PORTC &= 0b11000011;
			PORTC |= ( m_LedTimer << 2 );
		}
}


int main( )
{
 	 	cli( );
		Init_Mega48( );
	 	sei( );
	 	
	 	m_LedTimer = 1;
	 	
	 	while( 1 )
	 	{
			wdt_reset();
	 		if( IF_T_1MS_BIT( ) )
	 		{
	 			CLR_T_1MS_BIT( );
	 			timerdeal_Accout( );
	 		}
	 		
	 		if( IF_KEY_SCAN_BIT( ) )
	 		{
	 			CLR_KEY_SCAN_BIT( );
	 			Key_Scan( );
	 		}
	 		
	 		if( IF_T_500MS_BIT( ) )
	 		{
	 			CLR_T_500MS_BIT( );
	 			Led_Deal( );
	 		}
	 	}
	 	
}
